-------------------------------------------------------------------------------
--! @file       GF5M15.vhd
--! @author     Ahmed Ferozpuri
--! @brief      GF Multier 5bit x 15
-------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY GF5M15 IS
	PORT(	d_i : IN  std_logic_vector(4 DOWNTO 0);
			d_o : OUT  std_logic_vector(4 DOWNTO 0)
		);
END GF5M15;

ARCHITECTURE behavioral OF GF5M15 IS

SIGNAL M21, M22, M23: std_logic_vector(4 DOWNTO 0);

BEGIN

	M21O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => d_i, d_o => M21);
	M22O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => M21, d_o => M22);
	M23O: ENTITY work.GF5M2(behavioral) PORT MAP(d_i => M22, d_o => M23);
	
	d_o <= d_i xor M21 xor M22 xor M23;
	
END behavioral;