-------------------------------------------------------------------------------
--! @file       SBOX.vhd
--! @author     Ahmed Ferozpuri
--! @brief      SBOX for PRIMATEs
-------------------------------------------------------------------------------
LIBRARY ieee; 
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL; 
 
ENTITY SBOX IS 
--4 5-bit values for the initial LFSR value of each permuatation (1-4)
 PORT (	addr : IN std_logic_vector(4 DOWNTO 0); 
			do : OUT std_logic_vector(4 DOWNTO 0)); 
END SBOX;

ARCHITECTURE behavioral OF SBOX IS
 TYPE rom_type IS ARRAY (0 TO 31) OF std_logic_vector (4 DOWNTO 0); 
 CONSTANT ROM_array : rom_type := ("00001", "00000", "11001", "11010",
											  "10001", "11101", "10101", "11011",
											  "10100", "00101", "00100", "10111",
											  "01110", "10010", "00010", "11100",
											  "01111", "01000", "00110", "00011",
											  "01101", "00111", "11000", "10000",
											  "11110", "01001", "11111", "01010",
											  "10110", "01100", "01011", "10011");
--1,0,25,26,17,29,21,27,
--20,5,4,23,14,18,2,28,
--15,8,6,3,13,7,24,16
--30,9,31,10,22,12,11,19
BEGIN 
 do <= ROM_array(to_integer(unsigned(addr))); 
END behavioral;

